



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C预处理和C库</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C预处理和C库</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:01:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;
 #define MAN(x) "n"##x
 int main(void)
 {
     printf("%s",MAN("dd"));
     ;
 }</pre>
</div>
<p>这里我说一下，几个我曾犯的错误，首先，将#define错写成了#include</p>
<p>报错error C2006: #include expected a filename, found 'identifier'</p>
<p>当我搜索时发现了这么别人问的一个问题</p>
<p>#include&nbsp;"asclass.h"<br />//asclass.h有语句#define&nbsp;ASData_i&nbsp;"asdata.h"<br />#include&nbsp;&nbsp;ASData_i</p>
<p>这样编译,报错:error&nbsp;C2006:&nbsp;#include&nbsp;expected&nbsp;a&nbsp;filename,&nbsp;found&nbsp;'identifier'</p>
<p>怎么处理?</p>
<p>因为#define 和#include都是预处理。所以不会在#include处发生替换，所以编译器误认为你在添加头文件</p>
<p>还有，当你在处理替换字的类型时要注意，就像上面的"n"##x，如果你去掉&ldquo;&rdquo;，那么他就会将n当成是个变量</p>
<p><strong>指令 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 用途</strong></p>
<p># &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 　空指令，无任何效果</p>
<p>#include&nbsp;&nbsp;&nbsp; 包含一个源代码文件</p>
<p>#define&nbsp;&nbsp;&nbsp;&nbsp; 定义宏</p>
<p>#undef &nbsp; &nbsp; 取消已定义的宏</p>
<p>#if &nbsp; &nbsp; &nbsp; &nbsp; 　如果给定条件为真，则编译下面代码</p>
<p>#ifdef &nbsp; &nbsp;&nbsp; &nbsp;如果宏已经定义，则编译下面代码</p>
<p>#ifndef&nbsp;&nbsp;&nbsp;&nbsp; 如果宏没有定义，则编译下面代码</p>
<p>#elif&nbsp;&nbsp; &nbsp; &nbsp; &nbsp; 如果前面的#if给定条件不为真，当前条件为真，则编译下面代码</p>
<p>#endif&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 结束一个#if&hellip;&hellip;#else条件编译块</p>
<p>#error &nbsp; &nbsp;&nbsp; 停止编译并显示错误信息</p>
<p>　　 &nbsp;#else &nbsp; &nbsp; &nbsp;&nbsp;略</p>
<p>　　 #error &nbsp; &nbsp; 指令将使编译器显示一条错误信息，然后停止编译。</p>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#line &nbsp; &nbsp; &nbsp; &nbsp;指令可以改变编译器用来指出警告和错误信息的文件号和行号。</div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;#pragma &nbsp;指令没有正式的定义。编译器可以自定义其用途。典型的用法是禁止或允许某些烦人的警告信息。</div>
<div>
<p>#pragma message(&ldquo;消息文本&rdquo;)</p>
<p>　　当编译器遇到这条指令时就在编译输出窗口中将消息文本打印出来。</p>
</div>
<div>&nbsp;</div>
<p>条件预处理</p>
<p>#if defined x<br />等于<br />&nbsp; &nbsp; #ifdef x</p>
<p>#if !defined x<br />等于<br />&nbsp; &nbsp; #ifndef x</p>
<p>更详细的可以看http://www.cnblogs.com/mmfzmd517528/archive/2013/01/23/2872423.html</p>
<p>unknown character '0xa1'可能是在复制粘贴时，全角半角的错误</p>
<p>atexit()</p>
<div>#include&lt;stdlib.h&gt;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;int atexit(void(*func)(void));</div>
<div>&nbsp;</div>
<div>&nbsp;&nbsp;&nbsp;&nbsp;其中，atexit的参数是一个函数地址，当调用此函数时无须传递任何参数，该函数也不能返回值，atexit函数称为终止处理程序注册程序，注册完成以后，当函数终止是exit()函数会主动的调用前面注册的各个函数，但是exit函数调用这些函数的顺序于这些函数登记的顺序是相反的</div>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;
 #include&lt;stdlib.h&gt;

 void func1(void)
 {
         printf("in func1\n");
 }

 void func2(void)
 {
         printf("in func2\n");
 }

 void func3(void)
 {
         printf("in func3\n");
 }

 int main()
 {
         atexit(func3);
         atexit(func2);
         atexit(func1);

         printf("In main\n");

         ;
 }结果是</pre>
</div>
<ol><li>In&nbsp;main</li>
<li>in&nbsp;func1</li>
<li>in&nbsp;func2</li>
<li>in&nbsp;func3</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlvwy69.html">使用JDBC访问SQLServer 2008</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx11ve9.html">洛谷  P1908 逆序对 Label：归并排序&vert;&vert;树状数组 不懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd615z8.html">ASP&period;NET关于Login控件使用 &lpar;转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xpkgn9.html">第一个MySQL 存储过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdpmvl8.html">解决WEB（apache&rpar;服务器time&lowbar;wait过高的性能优化过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdrv0m8.html">抓取锁的sql语句-第一次修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj50n09.html">linux 下的 mkfifo、exec 命令使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zk77j9.html">How to change current process to background process</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zv36e9.html">tensorflow安装篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd5pg79.html">安装yum源和gcc编译器遇到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz43ge8.html">Python&lowbar;将指定文件夹中的文件压缩至已有压缩包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk366d8.html">《k8s-1&period;13版本源码分析》-调度预选</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kemz29.html">Spring Boot&colon;The field file exceeds its maximum permitted size of 1048576 bytes</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gmllvq.html">Kali Linux之常见后门工具介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvyw3k8.html">JS的document&period;images函数使用示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvlokq.html">mssql for xml path使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e43m7m9.html">ceph crush的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oyg5e8.html">python中&lowbar;&lowbar;call&lowbar;&lowbar;&lpar;&rpar;方法的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r526emq.html">雷林鹏分享：XML 命名空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2g47j9.html">go语言练习：指针</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/495kwyz9.html">windows系统服务编程代码示例分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gv5y49.html">POJ 3020 Antenna Placement 匈牙利算法&comma;最大流解法 难度&colon;1</a>
			</li>
						<li><a href="https://www.batexi.com/a/390xyon9.html">CSipSimple结构浅析</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9po7pdq.html">C&num;面向对象总结2</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8el3oeq.html">python leetcode 日记--231&period; Power of Two</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932330q.html">Apache&plus;Tomcat构建Tomcat负载均衡集群</a>
			</li>
						<li><a href="https://www.batexi.com/a/r932ronq.html">day14&lowbar;API第四天</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql3djeq.html">Scalding初探之二：动手来做做小实验</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j46ve9.html">快速判断ie10及以上版本浏览器</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kg6l69.html">java&period;util&period;NoSuchElementException解决办法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
